= nng_strdup(3)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_strdup - duplicate string

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>

char *nng_strdup(const char *src);
----

== DESCRIPTION

The `nng_strdup()` duplicates the string _src_ and returns it.

This is logically equivalent to using xref:nng_alloc.3.adoc[`nng_alloc()`]
to allocate a region of memory of `strlen(s) + 1` bytes, and then
using `strcpy()` to copy the string into the destination before
returning it.

The returned string should be deallocated with
xref:nng_strfree.3.adoc[`nng_strfree()`], or may be deallocated using the
xref:nng_free.3.adoc[`nng_free()`] using the length of the returned string plus
one (for the `NUL` terminating byte).

IMPORTANT: Do not use the system `free()` or similar functions to deallocate
the string, since those may use a different memory arena!

== RETURN VALUES

This function returns the new string on success, and `NULL` on failure.

== ERRORS

No errors are returned, but a `NULL` return value should be
treated the same as `NNG_ENOMEM`.

== SEE ALSO

[.text-left]
xref:nng_alloc.3.adoc[nng_alloc(3)],
xref:nng_free.3.adoc[nng_free(3)],
xref:nng.7.adoc[nng(7)]
